unit Unit1;

interface

uses
    Windows, SysUtils, Classes, Graphics, ExtCtrls, StdCtrls, ComCtrls,
  Forms, Controls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Status: TStatusBar;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    Panel3: TPanel;
    ScrollH: TScrollBar;
    Panel4: TPanel;
    ScrollV: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ScrollHChange(Sender: TObject);
    procedure ScrollVChange(Sender: TObject);
  private
    procedure UpdateStatus();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    iEdit;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[NGCg
procedure TForm1.FormCreate(Sender: TObject);
begin
    PaintBox1.Canvas.Font.Assign(Self.Font);
    Editor := TSprictEditor.Create(PaintBox1);
    UpdateStatus();
    PaintBox1.Repaint;
end;

//-----------------------------------------------------------------------------
//  XV
procedure TForm1.UpdateStatus();
begin
    Status.Panels[0].Text := Editor.PosToString();
    Status.Panels[1].Text := Editor.ScrollToString();
end;

//-----------------------------------------------------------------------------
//  L[{[h(KeyPreview = true ɂĂ)
procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
    Editor.KeyPress(Key);
end;

//-----------------------------------------------------------------------------
//  L[
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
    x, y: integer;
begin
    Editor.GetImePosition(x, y);
    SetImeCompositionWindow(Editor.Font, x, y);
    UpdateStatus();
    Editor.KeyDown(Key, Shift);
end;

//-----------------------------------------------------------------------------
//  `
procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
    PaintBox1.Canvas.Brush.Color := clWindow;
    PaintBox1.Canvas.FillRect(PaintBox1.ClientRect);
    Editor.Paint();
end;

//-----------------------------------------------------------------------------
//  XN[
procedure TForm1.ScrollHChange(Sender: TObject);
begin
    Editor.ScrollH(ScrollH.Position);
end;

//-----------------------------------------------------------------------------
//  cXN[
procedure TForm1.ScrollVChange(Sender: TObject);
begin
    Editor.ScrollV(ScrollV.Position);
end;

end.

